

# GetModel
<a name="API_GetModel"></a>

Describes an existing model defined for a RestApi resource.

## Request Syntax
<a name="API_GetModel_RequestSyntax"></a>

```
GET /restapis/restapi_id/models/model_name?flatten=flatten HTTP/1.1
```

## URI Request Parameters
<a name="API_GetModel_RequestParameters"></a>

The request uses the following URI parameters.

 ** [flatten](#API_GetModel_RequestSyntax) **   <a name="apigw-GetModel-request-uri-flatten"></a>
A query parameter of a Boolean value to resolve (`true`) all external model references and returns a flattened model schema or not (`false`) The default is `false`.

 ** [model\$1name](#API_GetModel_RequestSyntax) **   <a name="apigw-GetModel-request-uri-modelName"></a>
The name of the model as an identifier.  
Required: Yes

 ** [restapi\$1id](#API_GetModel_RequestSyntax) **   <a name="apigw-GetModel-request-uri-restApiId"></a>
The RestApi identifier under which the Model exists.  
Required: Yes

## Request Body
<a name="API_GetModel_RequestBody"></a>

The request does not have a request body.

## Response Syntax
<a name="API_GetModel_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "contentType": "string",
   "description": "string",
   "id": "string",
   "name": "string",
   "schema": "string"
}
```

## Response Elements
<a name="API_GetModel_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [contentType](#API_GetModel_ResponseSyntax) **   <a name="apigw-GetModel-response-contentType"></a>
The content-type for the model.  
Type: String

 ** [description](#API_GetModel_ResponseSyntax) **   <a name="apigw-GetModel-response-description"></a>
The description of the model.  
Type: String

 ** [id](#API_GetModel_ResponseSyntax) **   <a name="apigw-GetModel-response-id"></a>
The identifier for the model resource.  
Type: String

 ** [name](#API_GetModel_ResponseSyntax) **   <a name="apigw-GetModel-response-name"></a>
The name of the model. Must be an alphanumeric string.  
Type: String

 ** [schema](#API_GetModel_ResponseSyntax) **   <a name="apigw-GetModel-response-schema"></a>
The schema for the model. For `application/json` models, this should be JSON schema draft 4 model. Do not include "\$1\$1/" characters in the description of any properties because such "\$1\$1/" characters may be interpreted as the closing marker for comments in some languages, such as Java or JavaScript, causing the installation of your API's SDK generated by API Gateway to fail.  
Type: String

## Errors
<a name="API_GetModel_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** BadRequestException **   
The submitted request is not valid, for example, the input is incomplete or incorrect. See the accompanying error message for details.  
HTTP Status Code: 400

 ** NotFoundException **   
The requested resource is not found. Make sure that the request URI is correct.  
HTTP Status Code: 404

 ** TooManyRequestsException **   
The request has reached its throttling limit. Retry after the specified time period.  
HTTP Status Code: 429

 ** UnauthorizedException **   
The request is denied because the caller has insufficient permissions.  
HTTP Status Code: 401

## Examples
<a name="API_GetModel_Examples"></a>

### Retrieve a named Model resource representing an API data model
<a name="API_GetModel_Example_1"></a>

This example illustrates one usage of GetModel.

#### Sample Request
<a name="API_GetModel_Example_1_Request"></a>

```
GET /restapis/uojnr9hd57/models/output HTTP/1.1
Content-Type: application/x-amz-json-1.1
Host: apigateway.us-east-1.amazonaws.com
X-Amz-Date: 20160614T000826Z
Authorization: AWS4-HMAC-SHA256 Credential={access_key_ID}/20160614/us-east-1/apigateway/aws4_request, SignedHeaders=content-type;host;x-amz-date, Signature={sig4_hash}
```

#### Sample Response
<a name="API_GetModel_Example_1_Response"></a>

```
{
  "_links": {
    "curies": {
      "href": "https://docs.aws.amazon.com/apigateway/latest/developerguide/restapi-model-{rel}.html",
      "name": "model",
      "templated": true
    },
    "self": {
      "href": "/restapis/uojnr9hd57/models/output?flatten=false"
    },
    "model:create": {
      "href": "/restapis/uojnr9hd57/models"
    },
    "model:delete": {
      "href": "/restapis/uojnr9hd57/models/output"
    },
    "model:generate-template": {
      "href": "/restapis/uojnr9hd57/models/output/default_template"
    },
    "model:update": {
      "href": "/restapis/uojnr9hd57/models/output"
    }
  },
  "contentType": "application/json",
  "id": "hkhn0z",
  "name": "output",
  "schema": "{\n\t\"title\": \"Calc output\",\n\t\"type\": \"object\",\n\t\"properties\": {\n\t\t\"a\": {\n\t\t\t\"type\": \"number\"\n\t\t},\n\t\t\"b\": {\n\t\t\t\"type\": \"number\"\n\t\t},\n\t\t\"op\": {\n\t\t\t\"description\": \"operations of +-*/\",\n\t\t\t\"type\": \"string\"\n\t\t},\n\t\t\"c\": {\n\t\t    \"type\": \"number\"\n\t\t}\n\t},\n\t\"required\": [\"a\", \"b\", \"op\"]\n}\n"
}
```

## See Also
<a name="API_GetModel_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/apigateway-2015-07-09/GetModel) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/apigateway-2015-07-09/GetModel) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/apigateway-2015-07-09/GetModel) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/apigateway-2015-07-09/GetModel) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/apigateway-2015-07-09/GetModel) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/apigateway-2015-07-09/GetModel) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/apigateway-2015-07-09/GetModel) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/apigateway-2015-07-09/GetModel) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/apigateway-2015-07-09/GetModel) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/apigateway-2015-07-09/GetModel) 